/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.127 Revision 1.159
1# Copyright 1999-2012 Gentoo Foundation 1# Copyright 1999-2015 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.127 2012/05/02 17:09:17 pesa Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.159 2015/03/06 14:08:07 dlan Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Qt herd <qt@gentoo.org> 7# Qt herd <qt@gentoo.org>
8# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
9# @DESCRIPTION: 9# @DESCRIPTION:
10# This eclass contains various functions that are used when building Qt4. 10# This eclass contains various functions that are used when building Qt4.
11 11
12case ${EAPI} in 12case ${EAPI} in
13 2|3|4) : ;; 13 4|5) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;; 14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac 15esac
16 16
17inherit base eutils flag-o-matic multilib toolchain-funcs versionator 17inherit eutils flag-o-matic multilib toolchain-funcs
18 18
19if [[ ${PV} == *9999* ]]; then 19HOMEPAGE="https://www.qt.io/ https://qt-project.org/"
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )" 20LICENSE="|| ( LGPL-2.1 GPL-3 )"
21SLOT="4"
28 22
29MY_PV=${PV/_/-} 23case ${PV} in
30MY_P=qt-everywhere-opensource-src-${MY_PV} 24 4.?.9999)
31 25 QT4_BUILD_TYPE="live"
32case ${QT4_BUILD_TYPE} in 26 EGIT_REPO_URI=(
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git 27 "git://gitorious.org/qt/qt.git"
35 https://git.gitorious.org/qt/qt.git" 28 "https://git.gitorious.org/qt/qt.git"
29 )
36 EGIT_BRANCH="${PV%.9999}" 30 EGIT_BRANCH=${PV%.9999}
31 inherit git-r3
37 ;; 32 ;;
38 release) 33 *)
39 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 34 QT4_BUILD_TYPE="release"
35 MY_P=qt-everywhere-opensource-src-${PV/_/-}
36 SRC_URI="http://download.qt.io/archive/qt/${PV%.*}/${PV}/${MY_P}.tar.gz"
37 S=${WORKDIR}/${MY_P}
40 ;; 38 ;;
41esac 39esac
42 40
43IUSE="aqua debug pch" 41IUSE="aqua debug pch"
44if [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]]; then 42[[ ${PN} != qtxmlpatterns ]] && IUSE+=" +exceptions"
45 IUSE+=" +exceptions"
46fi
47if version_is_at_least 4.8; then
48 IUSE+=" c++0x qpa"
49fi
50 43
51DEPEND="virtual/pkgconfig" 44DEPEND="virtual/pkgconfig"
52if [[ ${QT4_BUILD_TYPE} == live ]]; then 45if [[ ${QT4_BUILD_TYPE} == live ]]; then
53 DEPEND+=" dev-lang/perl" 46 DEPEND+=" dev-lang/perl"
54fi 47fi
55 48
56RDEPEND="
57 !<x11-libs/qt-assistant-${PV}
58 !>x11-libs/qt-assistant-${PV}-r9999
59 !<x11-libs/qt-bearer-${PV}
60 !>x11-libs/qt-bearer-${PV}-r9999
61 !<x11-libs/qt-core-${PV}
62 !>x11-libs/qt-core-${PV}-r9999
63 !<x11-libs/qt-dbus-${PV}
64 !>x11-libs/qt-dbus-${PV}-r9999
65 !<x11-libs/qt-declarative-${PV}
66 !>x11-libs/qt-declarative-${PV}-r9999
67 !<x11-libs/qt-demo-${PV}
68 !>x11-libs/qt-demo-${PV}-r9999
69 !<x11-libs/qt-gui-${PV}
70 !>x11-libs/qt-gui-${PV}-r9999
71 !<x11-libs/qt-multimedia-${PV}
72 !>x11-libs/qt-multimedia-${PV}-r9999
73 !<x11-libs/qt-opengl-${PV}
74 !>x11-libs/qt-opengl-${PV}-r9999
75 !<x11-libs/qt-openvg-${PV}
76 !>x11-libs/qt-openvg-${PV}-r9999
77 !<x11-libs/qt-phonon-${PV}
78 !>x11-libs/qt-phonon-${PV}-r9999
79 !<x11-libs/qt-qt3support-${PV}
80 !>x11-libs/qt-qt3support-${PV}-r9999
81 !<x11-libs/qt-script-${PV}
82 !>x11-libs/qt-script-${PV}-r9999
83 !<x11-libs/qt-sql-${PV}
84 !>x11-libs/qt-sql-${PV}-r9999
85 !<x11-libs/qt-svg-${PV}
86 !>x11-libs/qt-svg-${PV}-r9999
87 !<x11-libs/qt-test-${PV}
88 !>x11-libs/qt-test-${PV}-r9999
89 !<x11-libs/qt-webkit-${PV}
90 !>x11-libs/qt-webkit-${PV}-r9999
91 !<x11-libs/qt-xmlpatterns-${PV}
92 !>x11-libs/qt-xmlpatterns-${PV}-r9999
93"
94
95S=${WORKDIR}/${MY_P}
96
97# @FUNCTION: qt4-build_pkg_setup 49# @FUNCTION: qt4-build_pkg_setup
98# @DESCRIPTION: 50# @DESCRIPTION:
99# Sets up PATH and LD_LIBRARY_PATH. 51# Sets up PATH and LD_LIBRARY_PATH.
100qt4-build_pkg_setup() { 52qt4-build_pkg_setup() {
101 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 53 # Warn users of possible breakage when downgrading to a previous release.
102
103 # Protect users by not allowing downgrades between releases
104 # Downgrading revisions within the same release should be allowed 54 # Downgrading revisions within the same release is safe.
105 if has_version '>'${CATEGORY}/${P}-r9999; then 55 if has_version ">${CATEGORY}/${P}-r9999:4"; then
106 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 56 ewarn
107 eerror
108 eerror "Sanity check to keep you from breaking your system:"
109 eerror " Downgrading Qt is completely unsupported and will break your system!"
110 eerror
111 die "aborting to save your system"
112 else
113 ewarn "Downgrading Qt is completely unsupported and will break your system!" 57 ewarn "Downgrading Qt is completely unsupported and can break your system!"
114 fi 58 ewarn
115 fi
116
117 if [[ ${PN} == qt-webkit ]]; then
118 eshopts_push -s extglob
119 if is-flagq '-g?(gdb)?([1-9])'; then
120 echo
121 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
122 ewarn "You may experience really long compilation times and/or increased memory usage."
123 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
124 ewarn "For more info check out bug #307861"
125 echo
126 fi
127 eshopts_pop
128 fi 59 fi
129 60
130 PATH="${S}/bin${PATH:+:}${PATH}" 61 PATH="${S}/bin${PATH:+:}${PATH}"
131 if [[ ${CHOST} != *-darwin* ]]; then 62 if [[ ${CHOST} != *-darwin* ]]; then
132 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 63 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
137 # avoid extract failure. 68 # avoid extract failure.
138 [[ ${CHOST} == *-apple-darwin* ]] && \ 69 [[ ${CHOST} == *-apple-darwin* ]] && \
139 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 70 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
140 ${QT4_EXTRACT_DIRECTORIES}" 71 ${QT4_EXTRACT_DIRECTORIES}"
141 fi 72 fi
142
143 if ! version_is_at_least 4.1 $(gcc-version); then
144 ewarn "Using a GCC version lower than 4.1 is not supported."
145 fi
146} 73}
74
75# @ECLASS-VARIABLE: PATCHES
76# @DEFAULT_UNSET
77# @DESCRIPTION:
78# Array variable containing all the patches to be applied. This variable
79# is expected to be defined in the global scope of ebuilds. Make sure to
80# specify the full path. This variable is used in src_prepare phase.
81#
82# Example:
83# @CODE
84# PATCHES=(
85# "${FILESDIR}/mypatch.patch"
86# "${FILESDIR}/patches_folder/"
87# )
88# @CODE
89
90# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
91# @DEFAULT_UNSET
92# @DESCRIPTION:
93# Space-separated list of directories that will be extracted
94# from Qt tarball.
147 95
148# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 96# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
97# @DEFAULT_UNSET
149# @DESCRIPTION: 98# @DESCRIPTION:
150# Arguments for build_target_directories. Takes the directories in which the
151# code should be compiled. This is a space-separated list.
152
153# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
154# @DESCRIPTION:
155# Space-separated list including the directories that will be extracted from 99# Space-separated list of directories that will be configured,
156# Qt tarball. 100# compiled, and installed. All paths must be relative to ${S}.
157 101
158# @FUNCTION: qt4-build_src_unpack 102# @FUNCTION: qt4-build_src_unpack
159# @DESCRIPTION: 103# @DESCRIPTION:
160# Unpacks the sources. 104# Unpacks the sources.
161qt4-build_src_unpack() { 105qt4-build_src_unpack() {
162 setqtenv 106 setqtenv
163 107
108 if [[ $(gcc-major-version) -lt 4 ]] || [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 4 ]]; then
109 ewarn
110 ewarn "Using a GCC version lower than 4.4 is not supported."
111 ewarn
112 fi
113
114 if [[ ${PN} == qtwebkit ]]; then
115 eshopts_push -s extglob
116 if is-flagq '-g?(gdb)?([1-9])'; then
117 ewarn
118 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
119 ewarn "You may experience really long compilation times and/or increased memory usage."
120 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
121 ewarn "For more info check out https://bugs.gentoo.org/307861"
122 ewarn
123 fi
124 eshopts_pop
125 fi
126
164 case ${QT4_BUILD_TYPE} in 127 case ${QT4_BUILD_TYPE} in
165 live) 128 live)
166 git-2_src_unpack 129 git-r3_src_unpack
167 ;; 130 ;;
168 release) 131 release)
169 local tarball="${MY_P}.tar.gz" target= targets= 132 local tarball="${MY_P}.tar.gz" target= targets=
170 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 133 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
171 src/{qbase,qt_targets,qt_install}.pri bin config.tests \ 134 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
179 eend $? || die "failed to unpack" 142 eend $? || die "failed to unpack"
180 ;; 143 ;;
181 esac 144 esac
182} 145}
183 146
184# @ECLASS-VARIABLE: PATCHES
185# @DEFAULT_UNSET
186# @DESCRIPTION:
187# PATCHES array variable containing all various patches to be applied.
188# This variable is expected to be defined in global scope of ebuild.
189# Make sure to specify the full path. This variable is utilised in
190# src_unpack/src_prepare phase, based on EAPI.
191#
192# @CODE
193# PATCHES=( "${FILESDIR}/mypatch.patch"
194# "${FILESDIR}/patches_folder/" )
195# @CODE
196
197# @FUNCTION: qt4-build_src_prepare 147# @FUNCTION: qt4-build_src_prepare
198# @DESCRIPTION: 148# @DESCRIPTION:
199# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 149# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
200# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf. 150# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in make.conf.
201qt4-build_src_prepare() { 151qt4-build_src_prepare() {
202 setqtenv 152 setqtenv
203 153
204 if [[ ${QT4_BUILD_TYPE} == live ]]; then 154 if [[ ${QT4_BUILD_TYPE} == live ]]; then
205 QTDIR="." ./bin/syncqt || die "syncqt failed" 155 QTDIR="." ./bin/syncqt || die "syncqt failed"
206 fi 156 fi
207 157
208 if version_is_at_least 4.7; then
209 # fix libX11 dependency on non X packages 158 # avoid X11 dependency in non-gui packages
210 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 159 local nolibx11_pkgs="qtbearer qtcore qtdbus qtscript qtsql qttest qtxmlpatterns"
211 has ${PN} ${nolibx11_pkgs} && qt_nolibx11 160 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
212
213 qt_assistant_cleanup
214 fi
215 161
216 if use aqua; then 162 if use aqua; then
217 # provide a proper macx-g++-64 163 # provide a proper macx-g++-64
218 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 164 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
219 165
220 sed -e '/^CONFIG/s:app_bundle::' \ 166 sed -e '/^CONFIG/s:app_bundle::' \
221 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 167 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
222 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 168 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
223 fi 169 fi
224 170
225 if [[ ${PN} != qt-core ]]; then 171 if [[ ${CATEGORY}/${PN} != dev-qt/qtcore ]]; then
226 skip_qmake_build 172 skip_qmake_build
227 skip_project_generation 173 skip_project_generation
228 symlink_binaries_to_buildtree 174 symlink_binaries_to_buildtree
229 fi 175 fi
230 176
231 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
232 # qmake bus errors with -O2 or -O3 but -O1 works
233 # Bug 373061
234 replace-flags -O[23] -O1
235 fi
236
237 # Bug 178652
238 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
239 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
240 append-flags -fno-gcse
241 fi
242
243 if use_if_iuse c++0x; then 177 if use_if_iuse c++0x; then
244 echo
245 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
246 ewarn "this is an official standard, some of the reverse dependencies"
247 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
248 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
249 ewarn "disabled."
250 echo
251 append-flags -std=c++0x 178 append-cxxflags -std=c++0x
252 fi
253
254 # Unsupported old gcc versions - hardened needs this :(
255 if [[ $(gcc-major-version) -lt 4 ]]; then
256 ewarn "Appending -fno-stack-protector to CXXFLAGS"
257 append-cxxflags -fno-stack-protector
258 # Bug 253127
259 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
260 -i mkspecs/common/g++.conf || die
261 fi 179 fi
262 180
263 # Bug 261632 181 # Bug 261632
264 if use ppc64; then 182 if use ppc64; then
265 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
266 append-flags -mminimal-toc 183 append-flags -mminimal-toc
184 fi
185
186 # Bug 373061
187 # qmake bus errors with -O2 or -O3 but -O1 works
188 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
189 replace-flags -O[23] -O1
190 fi
191
192 # Bug 417105
193 # graphite on gcc 4.7 causes miscompilations
194 if [[ $(gcc-version) == "4.7" ]]; then
195 filter-flags -fgraphite-identity
267 fi 196 fi
268 197
269 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache 198 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
270 sed -e "/^SYSTEM_VARIABLES=/i \ 199 sed -e "/^SYSTEM_VARIABLES=/i \
271 CC='$(tc-getCC)'\n\ 200 CC='$(tc-getCC)'\n\
272 CXX='$(tc-getCXX)'\n\ 201 CXX='$(tc-getCXX)'\n\
273 CFLAGS='${CFLAGS}'\n\ 202 CFLAGS='${CFLAGS}'\n\
274 CXXFLAGS='${CXXFLAGS}'\n\ 203 CXXFLAGS='${CXXFLAGS}'\n\
275 LDFLAGS='${LDFLAGS}'\n" \ 204 LDFLAGS='${LDFLAGS}'\n\
205 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
206 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
207 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
208 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
209 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
210 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
276 -i configure \ 211 -i configure \
277 || die "sed SYSTEM_VARIABLES failed" 212 || die "sed SYSTEM_VARIABLES failed"
278 213
279 # Respect CC, CXX, LINK and *FLAGS in config.tests 214 # Respect CC, CXX, LINK and *FLAGS in config.tests
280 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \ 215 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
281 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \ 216 sed -i -e "/bin\/qmake/ s: \"\$SRCDIR/: \
282 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \ 217 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
283 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \ 218 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
284 || die "sed config.tests failed" 219 || die "sed config.tests failed"
285
286 # Strip predefined CFLAGS from mkspecs (bug 312689)
287 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
288 220
289 # Bug 172219 221 # Bug 172219
290 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 222 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
291 223
292 if [[ ${CHOST} == *-darwin* ]]; then 224 if [[ ${CHOST} == *-darwin* ]]; then
354 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 286 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
355 # do not flirt with non-Prefix stuff, we're quite possessive 287 # do not flirt with non-Prefix stuff, we're quite possessive
356 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 288 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
357 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 289 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
358 290
359 base_src_prepare 291 # apply patches
292 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
293 epatch_user
360} 294}
361 295
362# @FUNCTION: qt4-build_src_configure 296# @FUNCTION: qt4-build_src_configure
363# @DESCRIPTION: 297# @DESCRIPTION:
364# Default configure phase 298# Default configure phase
370 -bindir ${QTBINDIR} 304 -bindir ${QTBINDIR}
371 -libdir ${QTLIBDIR} 305 -libdir ${QTLIBDIR}
372 -docdir ${QTDOCDIR} 306 -docdir ${QTDOCDIR}
373 -headerdir ${QTHEADERDIR} 307 -headerdir ${QTHEADERDIR}
374 -plugindir ${QTPLUGINDIR} 308 -plugindir ${QTPLUGINDIR}
375 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR}) 309 -importdir ${QTIMPORTDIR}
376 -datadir ${QTDATADIR} 310 -datadir ${QTDATADIR}
377 -translationdir ${QTTRANSDIR} 311 -translationdir ${QTTRANSDIR}
378 -sysconfdir ${QTSYSCONFDIR} 312 -sysconfdir ${QTSYSCONFDIR}
379 -examplesdir ${QTEXAMPLESDIR} 313 -examplesdir ${QTEXAMPLESDIR}
380 -demosdir ${QTDEMOSDIR} 314 -demosdir ${QTDEMOSDIR}
389 ppc-macos) conf+=" -arch ppc" ;; 323 ppc-macos) conf+=" -arch ppc" ;;
390 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;; 324 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
391 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;; 325 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
392 x86-macos) conf+=" -arch x86" ;; 326 x86-macos) conf+=" -arch x86" ;;
393 x86|x86-*) conf+=" -arch i386" ;; 327 x86|x86-*) conf+=" -arch i386" ;;
394 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;; 328 alpha|arm|arm64|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
395 hppa|sh) conf+=" -arch generic" ;; 329 hppa|sh) conf+=" -arch generic" ;;
396 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 330 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
397 esac 331 esac
398 332
399 conf+=" -platform $(qt_mkspecs_dir)" 333 conf+=" -platform $(qt_mkspecs_dir)"
409 conf+=" -no-separate-debug-info" 343 conf+=" -no-separate-debug-info"
410 344
411 # exceptions USE flag 345 # exceptions USE flag
412 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)" 346 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
413 347
414 # disable RPATH on Qt >= 4.8 (bug 380415) 348 # disable rpath (bug 380415), except on prefix (bug 417169)
415 version_is_at_least 4.8 && conf+=" -no-rpath" 349 use prefix || conf+=" -no-rpath"
416 350
417 # precompiled headers don't work on hardened, where the flag is masked 351 # precompiled headers don't work on hardened, where the flag is masked
418 conf+=" $(qt_use pch)" 352 conf+=" $(qt_use pch)"
419 353
420 # -reduce-relocations 354 # -reduce-relocations
433 if use_if_iuse glib; then 367 if use_if_iuse glib; then
434 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 368 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
435 # avoid the -pthread argument 369 # avoid the -pthread argument
436 conf+=" ${glibflags//-pthread}" 370 conf+=" ${glibflags//-pthread}"
437 unset glibflags 371 unset glibflags
438 fi
439
440 if use_if_iuse qpa; then
441 echo
442 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
443 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
444 ewarn "disable it before reporting any bugs related to this useflag."
445 echo
446 conf+=" -qpa"
447 fi 372 fi
448 373
449 if use aqua; then 374 if use aqua; then
450 # On (snow) leopard use the new (frameworked) cocoa code. 375 # On (snow) leopard use the new (frameworked) cocoa code.
451 if [[ ${CHOST##*-darwin} -ge 9 ]]; then 376 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
489# @FUNCTION: qt4-build_src_test 414# @FUNCTION: qt4-build_src_test
490# @DESCRIPTION: 415# @DESCRIPTION:
491# Runs tests only in target directories. 416# Runs tests only in target directories.
492qt4-build_src_test() { 417qt4-build_src_test() {
493 # QtMultimedia does not have any test suite (bug #332299) 418 # QtMultimedia does not have any test suite (bug #332299)
494 [[ ${PN} == qt-multimedia ]] && return 419 [[ ${CATEGORY}/${PN} == dev-qt/qtmultimedia ]] && return
495 420
496 for dir in ${QT4_TARGET_DIRECTORIES}; do 421 for dir in ${QT4_TARGET_DIRECTORIES}; do
497 emake -j1 check -C ${dir} 422 emake -j1 check -C ${dir}
498 done 423 done
499} 424}
543 468
544# @FUNCTION: qt4-build_src_install 469# @FUNCTION: qt4-build_src_install
545# @DESCRIPTION: 470# @DESCRIPTION:
546# Perform the actual installation including some library fixes. 471# Perform the actual installation including some library fixes.
547qt4-build_src_install() { 472qt4-build_src_install() {
548 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
549 setqtenv 473 setqtenv
550 474
551 install_directories ${QT4_TARGET_DIRECTORIES} 475 install_directories ${QT4_TARGET_DIRECTORIES}
552 install_qconfigs 476 install_qconfigs
553 fix_library_files 477 fix_library_files
554 fix_includes 478 fix_includes
555 479
556 # remove .la files since we are building only shared Qt libraries 480 # remove .la files since we are building only shared libraries
557 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f 481 prune_libtool_files
558} 482}
559 483
560# @FUNCTION: setqtenv 484# @FUNCTION: setqtenv
561# @INTERNAL 485# @INTERNAL
562setqtenv() { 486setqtenv() {
563 # Set up installation directories 487 # Set up installation directories
564 QTPREFIXDIR=${EPREFIX}/usr 488 QTPREFIXDIR=${EPREFIX}/usr
565 QTBINDIR=${EPREFIX}/usr/bin 489 QTBINDIR=${QTPREFIXDIR}/bin
566 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 490 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
567 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 491 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
568 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 492 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
569 QTHEADERDIR=${EPREFIX}/usr/include/qt4 493 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
570 QTPLUGINDIR=${QTLIBDIR}/plugins 494 QTPLUGINDIR=${QTLIBDIR}/plugins
571 QTIMPORTDIR=${QTLIBDIR}/imports 495 QTIMPORTDIR=${QTLIBDIR}/imports
572 QTDATADIR=${EPREFIX}/usr/share/qt4 496 QTDATADIR=${QTPREFIXDIR}/share/qt4
573 QTTRANSDIR=${QTDATADIR}/translations 497 QTTRANSDIR=${QTDATADIR}/translations
574 QTSYSCONFDIR=${EPREFIX}/etc/qt4 498 QTSYSCONFDIR=${EPREFIX}/etc/qt4
575 QTEXAMPLESDIR=${QTDATADIR}/examples 499 QTEXAMPLESDIR=${QTDATADIR}/examples
576 QTDEMOSDIR=${QTDATADIR}/demos 500 QTDEMOSDIR=${QTDATADIR}/demos
577 QMAKE_LIBDIR_QT=${QTLIBDIR} 501 QMAKE_LIBDIR_QT=${QTLIBDIR}
578 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
579 502
580 PLATFORM=$(qt_mkspecs_dir) 503 PLATFORM=$(qt_mkspecs_dir)
581
582 unset QMAKESPEC 504 unset QMAKESPEC
505
506 export XDG_CONFIG_HOME="${T}"
583} 507}
584 508
585# @FUNCTION: prepare_directories 509# @FUNCTION: prepare_directories
586# @USAGE: < directories > 510# @USAGE: < directories >
587# @INTERNAL 511# @INTERNAL
589# Generates Makefiles for the given list of directories. 513# Generates Makefiles for the given list of directories.
590prepare_directories() { 514prepare_directories() {
591 for x in "$@"; do 515 for x in "$@"; do
592 pushd "${S}"/${x} >/dev/null || die 516 pushd "${S}"/${x} >/dev/null || die
593 einfo "Running qmake in: ${x}" 517 einfo "Running qmake in: ${x}"
594 # avoid running over the maximum argument number, bug #299810 518 "${S}"/bin/qmake \
595 { 519 "LIBS+=-L${QTLIBDIR}" \
596 echo "${S}"/mkspecs/common/*.conf 520 "CONFIG+=nostrip" \
597 find "${S}" -name '*.pr[io]' 521 || die "qmake failed"
598 } | xargs sed -i \
599 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
600 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
601 || die
602 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
603 popd >/dev/null || die 522 popd >/dev/null || die
604 done 523 done
605} 524}
606
607 525
608# @FUNCTION: build_directories 526# @FUNCTION: build_directories
609# @USAGE: < directories > 527# @USAGE: < directories >
610# @INTERNAL 528# @INTERNAL
611# @DESCRIPTION: 529# @DESCRIPTION:
612# Compiles the code in the given list of directories. 530# Compiles the code in the given list of directories.
613build_directories() { 531build_directories() {
614 for x in "$@"; do 532 for x in "$@"; do
615 pushd "${S}"/${x} >/dev/null || die 533 pushd "${S}"/${x} >/dev/null || die
534 emake \
535 AR="$(tc-getAR) cqs" \
616 emake CC="$(tc-getCC)" \ 536 CC="$(tc-getCC)" \
617 CXX="$(tc-getCXX)" \ 537 CXX="$(tc-getCXX)" \
618 LINK="$(tc-getCXX)" || die "emake failed" 538 LINK="$(tc-getCXX)" \
539 RANLIB=":" \
540 STRIP=":"
619 popd >/dev/null || die 541 popd >/dev/null || die
620 done 542 done
621} 543}
622 544
623# @FUNCTION: install_directories 545# @FUNCTION: install_directories
626# @DESCRIPTION: 548# @DESCRIPTION:
627# Runs emake install in the given directories, which are separated by spaces. 549# Runs emake install in the given directories, which are separated by spaces.
628install_directories() { 550install_directories() {
629 for x in "$@"; do 551 for x in "$@"; do
630 pushd "${S}"/${x} >/dev/null || die 552 pushd "${S}"/${x} >/dev/null || die
631 emake INSTALL_ROOT="${D}" install || die "emake install failed" 553 emake INSTALL_ROOT="${D}" install
632 popd >/dev/null || die 554 popd >/dev/null || die
633 done 555 done
634} 556}
635 557
636# @ECLASS-VARIABLE: QCONFIG_ADD 558# @ECLASS-VARIABLE: QCONFIG_ADD
657 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 579 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
658 for x in QCONFIG_ADD QCONFIG_REMOVE; do 580 for x in QCONFIG_ADD QCONFIG_REMOVE; do
659 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 581 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
660 done 582 done
661 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo 583 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
662 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 584 doins "${T}"/${PN}-qconfig.pri
663 fi 585 fi
664 586
665 if [[ -n ${QCONFIG_DEFINE} ]]; then 587 if [[ -n ${QCONFIG_DEFINE} ]]; then
666 for x in ${QCONFIG_DEFINE}; do 588 for x in ${QCONFIG_DEFINE}; do
667 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 589 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
668 done 590 done
669 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo 591 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
670 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 592 doins "${T}"/gentoo-${PN}-qconfig.h
671 fi 593 fi
672} 594}
673 595
674# @FUNCTION: generate_qconfigs 596# @FUNCTION: generate_qconfigs
675# @INTERNAL 597# @INTERNAL
676# @DESCRIPTION: 598# @DESCRIPTION:
677# Generates gentoo-specific qconfig.{h,pri}. 599# Generates gentoo-specific qconfig.{h,pri}.
678generate_qconfigs() { 600generate_qconfigs() {
679 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then 601 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == dev-qt/qtcore ]]; then
680 local x qconfig_add qconfig_remove qconfig_new 602 local x qconfig_add qconfig_remove qconfig_new
681 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 603 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
682 [[ -f ${x} ]] || continue 604 [[ -f ${x} ]] || continue
683 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 605 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
684 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 606 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
685 done 607 done
686 608
687 # these error checks do not use die because dying in pkg_post{inst,rm} 609 # these error checks do not use die because dying in pkg_post{inst,rm}
688 # just makes things worse. 610 # just makes things worse.
689 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 611 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
690 # start with the qconfig.pri that qt-core installed 612 # start with the qconfig.pri that qtcore installed
691 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \ 613 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \
692 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 614 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
693 eerror "cp qconfig failed." 615 eerror "cp qconfig failed."
694 return 1 616 return 1
695 fi 617 fi
747} 669}
748 670
749# @FUNCTION: skip_qmake_build 671# @FUNCTION: skip_qmake_build
750# @INTERNAL 672# @INTERNAL
751# @DESCRIPTION: 673# @DESCRIPTION:
752# Patches configure to skip qmake compilation, as it's already installed by qt-core. 674# Patches configure to skip qmake compilation, as it's already installed by qtcore.
753skip_qmake_build() { 675skip_qmake_build() {
754 sed -i -e "s:if true:if false:g" "${S}"/configure || die 676 sed -i -e "s:if true:if false:g" "${S}"/configure || die
755} 677}
756 678
757# @FUNCTION: skip_project_generation 679# @FUNCTION: skip_project_generation
862 fi 784 fi
863 785
864 echo "${spec}" 786 echo "${spec}"
865} 787}
866 788
867# @FUNCTION: qt_assistant_cleanup
868# @INTERNAL
869# @DESCRIPTION:
870# Tries to clean up tools.pro for qt-assistant ebuilds.
871# Meant to be called in src_prepare().
872# Since Qt 4.7.4 this function is a no-op.
873qt_assistant_cleanup() {
874 # apply patching to qt-assistant ebuilds only
875 [[ ${PN} != qt-assistant ]] && return
876
877 # no longer needed for 4.7.4 and later
878 version_is_at_least 4.7.4 && return
879
880 # different versions (and branches...) may need different handling,
881 # add a case if you need special handling
882 case "${MY_PV_EXTRA}" in
883 *kde-qt*)
884 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
885 -e "/mac/,/^embedded.*makeqpf$/d" \
886 -i tools/tools.pro || die "patching tools.pro failed"
887 ;;
888 *)
889 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
890 -e "/mac/,/^embedded.*makeqpf$/d" \
891 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
892 -i tools/tools.pro || die "patching tools.pro failed"
893 ;;
894 esac
895}
896
897# @FUNCTION: qt_nolibx11 789# @FUNCTION: qt_nolibx11
898# @INTERNAL 790# @INTERNAL
899# @DESCRIPTION: 791# @DESCRIPTION:
900# Ignore X11 tests for packages that don't need X libraries installed. 792# Skip X11 tests for packages that don't need X libraries installed.
901qt_nolibx11() { 793qt_nolibx11() {
902 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure || 794 sed -i -e '/^if.*PLATFORM_X11.*CFG_GUI/,/^fi$/d' "${S}"/configure || die
903 die "x11 check sed failed"
904} 795}
905 796
906EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 797EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.127  
changed lines
  Added in v.1.159

  ViewVC Help
Powered by ViewVC 1.1.20